%VG11 uloha 1.1a (kolinearni transformace)
%RSC (rsc@email.cz)

clear %vymazani pameti
clc %smazani obrazovky


%=================================================================+
vg11_1_1_50 %nazev souboru s puvodnimi souradnicemi a polomerem   |
            %(zmenit cislo na konci podle individualniho zadani)  |
%=================================================================+

fid = fopen('1.1a.txt','w'); %vytvoreni *.txt souboru pro vystup

ss = ss_crd;
r = radius;

fprintf(fid,'VG11 - uloha 1.1a\n');
fprintf(fid,'-----------------\n\n');

%souradnice
y = 3;
x = 2;

Y = 5;
X = 4;

%body
A = 1;
B = 2;
C = 3;
D = 4;
E = 5;
F = 6;
G = 7;
H = 8;
I = 9;

ro = 200/pi;

% kostra vysledneho pravidelneho obrazce
hold on;
axis equal;
delta = (abs(ss(C,X) - ss(A,X)))/10;
axis([ss(A,X)-delta ss(C,X)+delta ss(A,Y)-delta ss(G,Y)+delta]);
title('Kolinearn transformace','FontWeight','bold','FontSize',12,'FontAngle','italic','VerticalAlignment','bottom');
whitebg('white');


%plot([ss(A,x),ss(B,x),ss(C,x),ss(D,x),ss(E,x),ss(F,x),ss(G,x),ss(H,x),ss(A,x)],[ss(A,y),ss(B,y),ss(C,y),ss(D,y),ss(E,y),ss(F,y),ss(G,y),ss(H,y),ss(A,y)],'y') %puvodni ctyrctyruhelnik
plot([ss(A,X),ss(B,X),ss(C,X),ss(D,X),ss(E,X),ss(F,X),ss(G,X),ss(H,X),ss(A,X)],[ss(A,Y),ss(B,Y),ss(C,Y),ss(D,Y),ss(E,Y),ss(F,Y),ss(G,Y),ss(H,Y),ss(A,Y)],'r') %vysledny ctyrctyruhelnik
%plot([0,1,2,2,2,1,0,0,0,0],[0,0,0,1,2,2,2,2,1,0],'r') %ctverec

plot([ss(H,X),ss(I,X),ss(D,X)],[ss(H,Y),ss(I,Y),ss(D,Y)],'r') %vodorovna
%plot([0,1,2],[1,1,1],'r') %vodorovna

plot([ss(F,X),ss(I,X),ss(B,X)],[ss(F,Y),ss(I,Y),ss(B,Y)],'r') %svisla
%plot([1,1,1],[0,1,2],'r') %svisla

text(ss(A,X),ss(A,Y),'A ','FontWeight','bold','HorizontalAlignment','right','VerticalAlignment','top'); %popis rohu
text(ss(B,X),ss(B,Y),' B','FontWeight','bold','HorizontalAlignment','center','VerticalAlignment','top');
text(ss(C,X),ss(C,Y),' C','FontWeight','bold','VerticalAlignment','top');
text(ss(D,X),ss(D,Y),'  D','FontWeight','bold');
text(ss(E,X),ss(E,Y),' E','FontWeight','bold','VerticalAlignment','bottom');
text(ss(F,X),ss(F,Y),' F','FontWeight','bold','HorizontalAlignment','center','VerticalAlignment','bottom');
text(ss(G,X),ss(G,Y),'G ','FontWeight','bold','HorizontalAlignment','right','VerticalAlignment','bottom');
text(ss(H,X),ss(H,Y),'H  ','FontWeight','bold','HorizontalAlignment','right');
text(ss(I,X),ss(I,Y),' I','FontWeight','bold','VerticalAlignment','bottom');


xlabel('                                                                               x [m]');
ylabel('                                                                               y [m]');

%*****************************************************************************************
fprintf(fid,'=========================================\n');
fprintf(fid,'Obrazec HABI\n');
fprintf(fid,'=========================================\n');

% P ----------- S       H -- I
% |             |       |    |
% |   obecne    |       A -- B
% |             |
% |             |
% V-------------L

%=========================== ZADANI OBRAZCE =============================
P = H; %prave rameno
V = A; %vrchol                                                          <=====================================
L = B; %leve rameno
S = I; %stredovy bod
%========================================================================

%S1
x1 = ss(S,x);
y1 = ss(S,y);
x2 = ss(L,x);
y2 = ss(L,y);
x3 = ss(V,x);
y3 = ss(V,y);
x4 = ss(P,x);
y4 = ss(P,y);

%S2
X1 = ss(S,X);
Y1 = ss(S,Y);
X2 = ss(L,X);
Y2 = ss(L,Y);
X3 = ss(V,X);
Y3 = ss(V,Y);
X4 = ss(P,X);
Y4 = ss(P,Y);



A = [
x1 y1 1 0  0  0 -x1*X1 -y1*X1
0  0  0 x1 y1 1 -x1*Y1 -y1*Y1
x2 y2 1 0  0  0 -x2*X2 -y2*X2
0  0  0 x2 y2 1 -x2*Y2 -y2*Y2
x3 y3 1 0  0  0 -x3*X3 -y3*X3
0  0  0 x3 y3 1 -x3*Y3 -y3*Y3
x4 y4 1 0  0  0 -x4*X4 -y4*X4
0  0  0 x4 y4 1 -x4*Y4 -y4*Y4
];

dX = [
X1
Y1
X2
Y2
X3
Y3
X4
Y4
];

%transformacni koeficienty
a = inv(A)*dX;

a1 = a(1);
a2 = a(2);
a3 = a(3);
b1 = a(4);
b2 = a(5);
b3 = a(6);
c1 = a(7);
c2 = a(8);


fprintf(fid,'\nTransformacni koeficienty\n');
fprintf(fid,'-------------------------\n');

fprintf(fid,'a1 = %15.10f\n',a1);
fprintf(fid,'a2 = %15.10f\n',a2);
fprintf(fid,'a3 = %15.10f\n',a3);
fprintf(fid,'b1 = %15.10f\n',b1);
fprintf(fid,'b2 = %15.10f\n',b2);
fprintf(fid,'b3 = %15.10f\n',b3);
fprintf(fid,'c1 = %15.10f\n',c1);
fprintf(fid,'c2 = %15.10f\n\n',c2);

fprintf(fid,'Pruseciky s uhloprickami\n');
fprintf(fid,'------------------------\n');


%prusecik kruznice se stranou SP (IH)
s2 = atan2(ss(P,y)-ss(S,y),ss(P,x)-ss(S,x));

% if s2 < 0
%     s2 = s2 + 2*pi;
% end

yP = ss(S,y) + r * sin(s2); %S1
xP = ss(S,x) + r * cos(s2);

xt = xP;
yt = yP;

xPT = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
yPT = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);

fprintf(fid,'\txIH = %+.5f m\n',xPT); %                           <=====================================
fprintf(fid,'\tyIH = %+.5f m\n\n',yPT);
    

%prusecik kruznice se stranou SL (IB)
s1 = atan2(ss(L,y)-ss(S,y),ss(L,x)-ss(S,x));

% if s1 < 0
%     s1 = s1 + 2*pi;
% end

if s1 < s2 %osetreni obcasneho problemu s kvadranty
    s1 = s1 + 2*pi;
end

yL = ss(S,y) + r * sin(s1); %S1
xL = ss(S,x) + r * cos(s1);

xt = xL;
yt = yL;

xLT = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
yLT = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);

fprintf(fid,'\txIB = %+.5f m\n',xLT); %                           <=====================================
fprintf(fid,'\tyIB = %+.5f m\n\n',yLT);





% body na T kruznici
xkT = xPT;
ykT = yPT;

for i=s2:pi/100:s1 %pi/n je krok po nemz se pocitaji body na oblouku (cim vetsi n, tim hladsi oblouk)

    xt = ss(S,x) + r * cos(i); %body na kruznici (S1)
    yt = ss(S,y) + r * sin(i);
    
%    xk(end+1,1) = xt; %S1
%    yk(end+1,1) = yt;

    
    xkT(end+1,1) = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
    ykT(end+1,1) = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);
end

xkT(end+1,1) = xLT;
ykT(end+1,1) = yLT;

% body na T kruznici END


plot(xkT,ykT) %vykresleni oblouku

%plot([xPT,x1,xLT],[yPT,y1,yLT],'y') %BIH T (S2) --- ramena T oblouku
%plot([x4,x1,x2],[y4,y1,y2],'g') %BIH (S1) --- ramena puvodniho oblouku



%*****************************************************************************************
fprintf(fid,'=========================================\n');
fprintf(fid,'Obrazec BCDI\n');
fprintf(fid,'=========================================\n');

% P ----------- S       B -- I
% |             |       |    |
% |   obecne    |       C -- D
% |             |
% |             |
% V-------------L

%=========================== ZADANI OBRAZCE =============================
P = B; %prave rameno
V = C; %vrchol                                                          <=====================================
L = D; %leve rameno
S = I; %stredovy bod
%========================================================================


%S1
x1 = ss(S,x);
y1 = ss(S,y);
x2 = ss(L,x);
y2 = ss(L,y);
x3 = ss(V,x);
y3 = ss(V,y);
x4 = ss(P,x);
y4 = ss(P,y);

%S2
X1 = ss(S,X);
Y1 = ss(S,Y);
X2 = ss(L,X);
Y2 = ss(L,Y);
X3 = ss(V,X);
Y3 = ss(V,Y);
X4 = ss(P,X);
Y4 = ss(P,Y);



A = [
x1 y1 1 0  0  0 -x1*X1 -y1*X1
0  0  0 x1 y1 1 -x1*Y1 -y1*Y1
x2 y2 1 0  0  0 -x2*X2 -y2*X2
0  0  0 x2 y2 1 -x2*Y2 -y2*Y2
x3 y3 1 0  0  0 -x3*X3 -y3*X3
0  0  0 x3 y3 1 -x3*Y3 -y3*Y3
x4 y4 1 0  0  0 -x4*X4 -y4*X4
0  0  0 x4 y4 1 -x4*Y4 -y4*Y4
];

dX = [
X1
Y1
X2
Y2
X3
Y3
X4
Y4
];

%transformacni koeficienty
a = inv(A)*dX;

a1 = a(1);
a2 = a(2);
a3 = a(3);
b1 = a(4);
b2 = a(5);
b3 = a(6);
c1 = a(7);
c2 = a(8);

fprintf(fid,'\nTransformacni koeficienty\n');
fprintf(fid,'-------------------------\n');

fprintf(fid,'a1 = %15.10f\n',a1);
fprintf(fid,'a2 = %15.10f\n',a2);
fprintf(fid,'a3 = %15.10f\n',a3);
fprintf(fid,'b1 = %15.10f\n',b1);
fprintf(fid,'b2 = %15.10f\n',b2);
fprintf(fid,'b3 = %15.10f\n',b3);
fprintf(fid,'c1 = %15.10f\n',c1);
fprintf(fid,'c2 = %15.10f\n\n',c2);

fprintf(fid,'Pruseciky s uhloprickami\n');
fprintf(fid,'------------------------\n');


%prusecik kruznice se stranou SP (IH)
s2 = atan2(ss(P,y)-ss(S,y),ss(P,x)-ss(S,x));

% if s2 < 0
%     s2 = s2 + 2*pi;
% end

yP = ss(S,y) + r * sin(s2); %S1
xP = ss(S,x) + r * cos(s2);

xt = xP;
yt = yP;

xPT = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
yPT = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);

fprintf(fid,'\txIB = %+.5f m\n',xPT); %                           <=====================================
fprintf(fid,'\tyIB = %+.5f m\n\n',yPT);
    

%prusecik kruznice se stranou SL (IB)
s1 = atan2(ss(L,y)-ss(S,y),ss(L,x)-ss(S,x));

% if s1 < 0
%     s1 = s1 + 2*pi;
% end

if s1 < s2 %osetreni obcasneho problemu s kvadranty
    s1 = s1 + 2*pi;
end


yL = ss(S,y) + r * sin(s1); %S1
xL = ss(S,x) + r * cos(s1);

xt = xL;
yt = yL;

xLT = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
yLT = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);

fprintf(fid,'\txID = %+.5f m\n',xLT); %                           <=====================================
fprintf(fid,'\tyID = %+.5f m\n\n',yLT);





% body na T kruznici
xkT = xPT;
ykT = yPT;

for i=s2:pi/100:s1 %pi/n je krok po nemz se pocitaji body na oblouku (cim vetsi n, tim hladsi oblouk)

    xt = ss(S,x) + r * cos(i); %body na kruznici (S1)
    yt = ss(S,y) + r * sin(i);
    
%    xk(end+1,1) = xt; %S1
%    yk(end+1,1) = yt;

    
    xkT(end+1,1) = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
    ykT(end+1,1) = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);
end

xkT(end+1,1) = xLT;
ykT(end+1,1) = yLT;

% body na T kruznici END


plot(xkT,ykT) %vykresleni oblouku

%plot([xPT,x1,xLT],[yPT,y1,yLT],'y') %BIH T (S2) --- ramena T oblouku
%plot([x4,x1,x2],[y4,y1,y2],'g') %BIH (S1) --- ramena puvodniho oblouku




%*****************************************************************************************
fprintf(fid,'=========================================\n');
fprintf(fid,'Obrazec DEFI\n');
fprintf(fid,'=========================================\n');

% P ----------- S       D -- I
% |             |       |    |
% |   obecne    |       E -- F
% |             |
% |             |
% V-------------L

%=========================== ZADANI OBRAZCE =============================
P = D; %prave rameno
V = E; %vrchol                                                          <=====================================
L = F; %leve rameno
S = I; %stredovy bod
%========================================================================


%S1
x1 = ss(S,x);
y1 = ss(S,y);
x2 = ss(L,x);
y2 = ss(L,y);
x3 = ss(V,x);
y3 = ss(V,y);
x4 = ss(P,x);
y4 = ss(P,y);

%S2
X1 = ss(S,X);
Y1 = ss(S,Y);
X2 = ss(L,X);
Y2 = ss(L,Y);
X3 = ss(V,X);
Y3 = ss(V,Y);
X4 = ss(P,X);
Y4 = ss(P,Y);



A = [
x1 y1 1 0  0  0 -x1*X1 -y1*X1
0  0  0 x1 y1 1 -x1*Y1 -y1*Y1
x2 y2 1 0  0  0 -x2*X2 -y2*X2
0  0  0 x2 y2 1 -x2*Y2 -y2*Y2
x3 y3 1 0  0  0 -x3*X3 -y3*X3
0  0  0 x3 y3 1 -x3*Y3 -y3*Y3
x4 y4 1 0  0  0 -x4*X4 -y4*X4
0  0  0 x4 y4 1 -x4*Y4 -y4*Y4
];

dX = [
X1
Y1
X2
Y2
X3
Y3
X4
Y4
];

%transformacni koeficienty
a = inv(A)*dX;

a1 = a(1);
a2 = a(2);
a3 = a(3);
b1 = a(4);
b2 = a(5);
b3 = a(6);
c1 = a(7);
c2 = a(8);

fprintf(fid,'\nTransformacni koeficienty\n');
fprintf(fid,'-------------------------\n');

fprintf(fid,'a1 = %15.10f\n',a1);
fprintf(fid,'a2 = %15.10f\n',a2);
fprintf(fid,'a3 = %15.10f\n',a3);
fprintf(fid,'b1 = %15.10f\n',b1);
fprintf(fid,'b2 = %15.10f\n',b2);
fprintf(fid,'b3 = %15.10f\n',b3);
fprintf(fid,'c1 = %15.10f\n',c1);
fprintf(fid,'c2 = %15.10f\n\n',c2);

fprintf(fid,'Pruseciky s uhloprickami\n');
fprintf(fid,'------------------------\n');

%prusecik kruznice se stranou SP (IH)
s2 = atan2(ss(P,y)-ss(S,y),ss(P,x)-ss(S,x));

yP = ss(S,y) + r * sin(s2); %S1
xP = ss(S,x) + r * cos(s2);

xt = xP;
yt = yP;

xPT = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
yPT = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);

fprintf(fid,'\txID = %+.5f m\n',xPT); %                           <=====================================
fprintf(fid,'\tyID = %+.5f m\n\n',yPT);
    

%prusecik kruznice se stranou SL (IB)
s1 = atan2(ss(L,y)-ss(S,y),ss(L,x)-ss(S,x));

if s1 < s2 %osetreni obcasneho problemu s kvadranty
    s1 = s1 + 2*pi;
end

yL = ss(S,y) + r * sin(s1); %S1
xL = ss(S,x) + r * cos(s1);

xt = xL;
yt = yL;

xLT = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
yLT = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);

fprintf(fid,'\txIF = %+.5f m\n',xLT); %                           <=====================================
fprintf(fid,'\tyIF = %+.5f m\n\n',yLT);





% body na T kruznici
xkT = xPT;
ykT = yPT;

for i=s2:pi/100:s1 %pi/n je krok po nemz se pocitaji body na oblouku (cim vetsi n, tim hladsi oblouk)

    xt = ss(S,x) + r * cos(i); %body na kruznici (S1)
    yt = ss(S,y) + r * sin(i);
    
%    xk(end+1,1) = xt; %S1
%    yk(end+1,1) = yt;

    
    xkT(end+1,1) = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
    ykT(end+1,1) = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);
end

xkT(end+1,1) = xLT;
ykT(end+1,1) = yLT;

% body na T kruznici END


plot(xkT,ykT) %vykresleni oblouku

%plot([xPT,x1,xLT],[yPT,y1,yLT],'y') %BIH T (S2) --- ramena T oblouku
%plot([x4,x1,x2],[y4,y1,y2],'g') %BIH (S1) --- ramena puvodniho oblouku



%*****************************************************************************************
fprintf(fid,'=========================================\n');
fprintf(fid,'Obrazec FGHI\n');
fprintf(fid,'=========================================\n');

% P ----------- S       F -- I
% |             |       |    |
% |   obecne    |       G -- H
% |             |
% |             |
% V-------------L

%=========================== ZADANI OBRAZCE =============================
P = F; %prave rameno
V = G; %vrchol                                                          <=====================================
L = H; %leve rameno
S = I; %stredovy bod
%========================================================================


%S1
x1 = ss(S,x);
y1 = ss(S,y);
x2 = ss(L,x);
y2 = ss(L,y);
x3 = ss(V,x);
y3 = ss(V,y);
x4 = ss(P,x);
y4 = ss(P,y);

%S2
X1 = ss(S,X);
Y1 = ss(S,Y);
X2 = ss(L,X);
Y2 = ss(L,Y);
X3 = ss(V,X);
Y3 = ss(V,Y);
X4 = ss(P,X);
Y4 = ss(P,Y);



A = [
x1 y1 1 0  0  0 -x1*X1 -y1*X1
0  0  0 x1 y1 1 -x1*Y1 -y1*Y1
x2 y2 1 0  0  0 -x2*X2 -y2*X2
0  0  0 x2 y2 1 -x2*Y2 -y2*Y2
x3 y3 1 0  0  0 -x3*X3 -y3*X3
0  0  0 x3 y3 1 -x3*Y3 -y3*Y3
x4 y4 1 0  0  0 -x4*X4 -y4*X4
0  0  0 x4 y4 1 -x4*Y4 -y4*Y4
];

dX = [
X1
Y1
X2
Y2
X3
Y3
X4
Y4
];

%transformacni koeficienty
a = inv(A)*dX;

a1 = a(1);
a2 = a(2);
a3 = a(3);
b1 = a(4);
b2 = a(5);
b3 = a(6);
c1 = a(7);
c2 = a(8);

fprintf(fid,'\nTransformacni koeficienty\n');
fprintf(fid,'-------------------------\n');

fprintf(fid,'a1 = %15.10f\n',a1);
fprintf(fid,'a2 = %15.10f\n',a2);
fprintf(fid,'a3 = %15.10f\n',a3);
fprintf(fid,'b1 = %15.10f\n',b1);
fprintf(fid,'b2 = %15.10f\n',b2);
fprintf(fid,'b3 = %15.10f\n',b3);
fprintf(fid,'c1 = %15.10f\n',c1);
fprintf(fid,'c2 = %15.10f\n\n',c2);

fprintf(fid,'Pruseciky s uhloprickami\n');
fprintf(fid,'------------------------\n');

%prusecik kruznice se stranou SP (IH)
s2 = atan2(ss(P,y)-ss(S,y),ss(P,x)-ss(S,x));

% if s2 < 0
%     s2 = s2 + 2*pi;
% end

yP = ss(S,y) + r * sin(s2); %S1
xP = ss(S,x) + r * cos(s2);

xt = xP;
yt = yP;

xPT = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
yPT = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);

fprintf(fid,'\txIF = %+.5f m\n',xPT); %                           <=====================================
fprintf(fid,'\tyIF = %+.5f m\n\n',yPT);
    

%prusecik kruznice se stranou SL (IB)
s1 = atan2(ss(L,y)-ss(S,y),ss(L,x)-ss(S,x));

% if s1 < 0
%     s1 = s1 + 2*pi;
% end

if s1 < s2 %osetreni obcasneho problemu s kvadranty
    s1 = s1 + 2*pi;
end

yL = ss(S,y) + r * sin(s1); %S1
xL = ss(S,x) + r * cos(s1);

xt = xL;
yt = yL;

xLT = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
yLT = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);

fprintf(fid,'\txIH = %+.5f m\n',xLT); %                           <=====================================
fprintf(fid,'\tyIH = %+.5f m\n\n',yLT);





% body na T kruznici
xkT = xPT;
ykT = yPT;

for i=s2:pi/100:s1 %pi/n je krok po nemz se pocitaji body na oblouku (cim vetsi n, tim hladsi oblouk)

    xt = ss(S,x) + r * cos(i); %body na kruznici (S1)
    yt = ss(S,y) + r * sin(i);
    
%    xk(end+1,1) = xt; %S1
%    yk(end+1,1) = yt;

    
    xkT(end+1,1) = (a1*xt + a2*yt + a3)/(c1*xt + c2*yt + 1); %S2
    ykT(end+1,1) = (b1*xt + b2*yt + b3)/(c1*xt + c2*yt + 1);
end

xkT(end+1,1) = xLT;
ykT(end+1,1) = yLT;

% body na T kruznici END


plot(xkT,ykT) %vykresleni oblouku

%plot([xPT,x1,xLT],[yPT,y1,yLT],'y') %BIH T (S2) --- ramena T oblouku
%plot([x4,x1,x2],[y4,y1,y2],'g') %BIH (S1) --- ramena puvodniho oblouku

title('');
print -dpng 1.1a.png; %automaticky export do *.png
title('Kolinearn transformace','FontWeight','bold','FontSize',12,'FontAngle','italic','VerticalAlignment','bottom');


fclose(fid);
fprintf('Ciselne vysledky jsou ulozeny v souboru "1.1a.txt"\n v pracovnim adresari, graf jako obrazek "1.1a.png"');